//////////////////////////////
// gdx_date.c
// written by Michael Gibson
// released under the GPL
// copyright 2007-2015
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

char indi_check[55];
char filename[55];

char startdate[15];
int startdate_i;

char stopdate[15];
int stopdate_i;

char sevendate[15];
int sevendate_i;
int found_even=0;

char marrdate[15];
int marrdate_i;
int found_mar=0;

char divdate[15];
int divdate_i;
int found_div=0;

char fam_marr_date[15];
char fam_div_date[15];

char indi_fams[15];

int age;
int age_place;

char age_string[75];

int se_age;
int se_age_dif;
int se_place;

int mr_age;
int mr_place;

int di_age;
int di_place;
/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}

/////////////////////////////////////////////////////
// marr_date
// find an individuals marriage date
/////////////////////////////////////////////////////
static void marr_date(void)
{

char temp[99];
char fam[6];
int  fam_r;
char last_action[15];
int x=0;
int get_family=0;
int family_recorded=0;
FILE *fp;

fp=fopen(filename,"r+");

for(x=0;x<9999;x++){

  fgets(temp,80,fp);

//// Catches
//// 0 FAM  -> 1 MARR -> 2 DATE
  if(temp[0]=='2' && temp[2]=='D' && temp[3]=='A'){ //2 DATE
     for(x=7;x<75;x++){
        if(temp[x]=='\n') temp[x]='\0';
        if(temp[x]=='\r') temp[x]='\0';
        temp[x-7]=temp[x];
        if(temp[x]=='\n') temp[x]='\0';
        if(temp[x]=='\r') temp[x]='\0';
     }
     if(last_action[0]=='M' && last_action[1]=='A' && get_family==1){
       strcpy(fam_marr_date,temp);
       //printf("date recorded, marr \n");
       //break;
       found_mar=1;
     }
     if(last_action[0]=='D' && last_action[1]=='I' && get_family==1){
       strcpy(fam_div_date,temp);
       //printf("date recorded, div \n");
       //break;
       found_div=1;
     }

  }


  if(temp[0]=='1' && temp[2]=='M' && temp[3]=='A' && temp[4] =='R' && get_family==1){ //1 MARR
     strcpy(last_action,"MARR");
  }

  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='I' && temp[4] =='V' && get_family==1){ //1 DIV 
     strcpy(last_action,"DIV");
  }

 if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F'){ //Family 0 level start of record
      for(x=5;x<75;x++) if(temp[x]=='@' ||temp[x]=='F') temp[x]=' ';
      sprintf(fam,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      //printf("Family Record = %s == %s\n",fam,indi_fams);
      fam_r=atoi(fam);
      if(fam_r == atoi(indi_fams)){
        //printf("found family\n");
        family_recorded=1;
        get_family=1;
      }
      else get_family=0;
  }

  if(temp[0] == '0' && temp[2] == 'T' && temp[3] == 'R') break;

}// end for
fclose(fp);
}
//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  char last_action[15];

  char indi_name[95];
  int  indi_name_t;
  char indi_marrdate[90];
  int  indi_marrdate_t;
  char indi_divdate[90];
  int  indi_divdate_t;
  char indi_birtdate[90];
  int  indi_birtdate_t;
  char indi_buridate[90];
  int  indi_buridate_t;
  char indi_deathdate[90];
  int  indi_deathdate_t;
  char indi_evendate[90];
  int  indi_evendate_t;
  char indi_evennote[90];
  int  indi_evennote_t;
 
  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03, button_04, button_05;
  int label0,label1,label2,label3,label4,label5,label6;
  int label7,label8,label9,label10,label11, label12, label13;
  int flag1=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[1]);
  strcpy(indi_evennote,"No recorded Event");
  strcpy(indi_buridate," ");
  strcpy(indi_deathdate," ");
  strcpy(indi_evendate," ");
  strcpy(indi_marrdate," ");
  strcpy(indi_birtdate," ");
  strcpy(indi_divdate," ");

  fp5=fopen(argv[1],"r+");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Individual - Date Events",790,510);
  gdx_setwindowbg("images/bg.xpm",1);


  gdx_frame(45,18,660,395,"Individual data for GEDCOM ID:");

  button_01 = gdx_imagebutton(5,10,"images/close.xpm",destroy);

  label0 = gdx_label(argv[2],222,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  do{

    loopy++;

    //check for level 0

    fgets(input1,80,fp5);

    if (input1[0]=='0'){ //OK, we have a level 0
      //check for an individual
      //01234567890123
      //0 @I0001@ INDI

      if(input1[2]=='@' && input1[3]=='I' && input1[10]=='I' && input1[11]=='N'){
        indi_found=1;
      }

      if(indi_found==1){
        //Great!, the level 0 is an individual

        for(x=5;x<80;x++) if(input1[x]=='@' ||input1[x]=='I') input1[x]=' ';
        sprintf(indi_check,"%c%c%c%c",input1[4],input1[5],input1[6],input1[7]);

        //check to see if it is the idividual we are looking for 
        //printf("check '%s' = '%s'\n",indi_check,argv[2]);
        if(atoi(indi_check)==atoi(argv[2])){
          //hot grits! it is the idividual we were looking for
          //now read in the individual's information
          do{

            fgets(input1,80,fp5);

            if(input1[0]=='1' && input1[2]=='N' && input1[3]=='A'){     ///1 NAME
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];}
              strcpy(indi_name,input1);
            }


          // 0123456789012
          // 1 FAMS @F0469@
            if(input1[0]=='1' && input1[2]=='F' && input1[3]=='A' && input1[5]=='S'){
                sprintf(indi_fams,"%c%c%c%c",input1[9],input1[10],input1[11],input1[12]);
            }


// last actions

            if(input1[0]=='1' && input1[2]=='E' && input1[3]=='V' && input1[4] =='E'){ //1 EVEN
               strcpy(last_action,"EVEN");
            }

            if(input1[0]=='1' && input1[2]=='C' && input1[3]=='H' && input1[4] =='A'){ //1 CHAN
               strcpy(last_action,"CHAN");
            }

            if(input1[0]=='1' && input1[2]=='B' && input1[3]=='U' && input1[4] =='R'){ //1 BURI
              strcpy(last_action,"BURI");
            }

            if(input1[0]=='1' && input1[2]=='C' && input1[3]=='R' && input1[4] =='E'){ //1 CREM
              strcpy(last_action,"CREM");
            }

            if(input1[0]=='1' && input1[2]=='B' && input1[3]=='I'){ //1 BIRT
               strcpy(last_action,"BIRT");
            }

            if(input1[0]=='1' && input1[2]=='D' && input1[3]=='E' && input1[4] =='A'){ //1 DEAT
              strcpy(last_action,"DEAT");
            }

// Burial Date and Death Date

           if(input1[0]=='2' && input1[2]=='D' && input1[3]=='A'){ //2 DATE
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='B' && last_action[1]=='U'){
                strcpy(indi_buridate,input1);
              }
              if(last_action[0]=='B' && last_action[1]=='I'){
                strcpy(indi_birtdate,input1);
              }
              if(last_action[0]=='D' && last_action[1]=='E'){
                strcpy(indi_deathdate,input1);
              }
              if(last_action[0]=='E' && last_action[1]=='V'){
                strcpy(indi_evendate,input1);
                found_even=1;
                printf("found event\n");
              }

           }



           if(input1[0]=='2' && input1[2]=='N' && input1[3]=='O'){ //2 NOTE
              for(x=7;x<80;x++){
                if(input1[x]=='\n') input1[x]='\0';
                input1[x-7]=input1[x];
              }
              if(last_action[0]=='E' && last_action[1]=='V'){
                strcpy(indi_evennote,input1);
              }

           }


          //stop when I get to the next idividual

          }while(input1[0] != '0' );

          flag1=22;
        }
      }//if indi

    }//if 0 level

    if(input1[0]=='\0'){

      flag1=22;
      gdx_label("File read error!",50,50,1);
      printf("NULL found!");
    }
   
  }while(flag1!=22);


 marr_date();  // find marriage and divorce

  //display
  //Name
  label1 = gdx_label("Name:",50,35,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name_t=gdx_textentry(145,25,250,0);
  gdx_settextentry(indi_name_t,indi_name);

  //Birth Date
  label2=gdx_label("Birth Date:",50,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label2);
  indi_birtdate_t=gdx_textentry(145,75,100,0);
  gdx_settextentry(indi_birtdate_t,indi_birtdate);

  //marriage Date
  label3=gdx_label("Marriage Date:",50,110,0);
  gdx_setlabelbg("images/bg.xpm",1,label3);
  indi_marrdate_t=gdx_textentry(145,100,100,0);
  gdx_settextentry(indi_marrdate_t,fam_marr_date);

  //Divorce Date
  label13=gdx_label("Divorce Date:",50,135,0);
  gdx_setlabelbg("images/bg.xpm",1,label13);
  indi_divdate_t=gdx_textentry(145,125,100,0);
  gdx_settextentry(indi_divdate_t,fam_div_date); 

  //special event
  label4=gdx_label("Special Event:",50,160,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_evendate_t=gdx_textentry(145,150,100,0);
  gdx_settextentry(indi_evendate_t,indi_evendate);
  label5=gdx_label(indi_evennote,260,135,1);
  gdx_setlabelbg("images/white.xpm",1,label5);


  //Death Date
  label6=gdx_label("Death Date:",50,185,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  indi_deathdate_t=gdx_textentry(145,175,100,0);
  gdx_settextentry(indi_deathdate_t,indi_deathdate);


  //Burial Date
  label7=gdx_label("Burial Date:",50,210,0);
  gdx_setlabelbg("images/bg.xpm",1,label7);
  indi_buridate_t=gdx_textentry(145,200,100,0);
  gdx_settextentry(indi_buridate_t,indi_buridate);


  //// Start Drawing the time line info

  /// grab years
  for(x=6;x<15;x++) startdate[x-6]=indi_birtdate[x];
  for(x=6;x<15;x++) stopdate[x-6]=indi_deathdate[x];
  for(x=6;x<15;x++) sevendate[x-6]=indi_evendate[x];
  for(x=6;x<15;x++) marrdate[x-6]=fam_marr_date[x];
  for(x=6;x<15;x++) divdate[x-6]=fam_div_date[x];

  startdate_i=atoi(startdate);
  stopdate_i=atoi(stopdate);
  sevendate_i=atoi(sevendate);
  marrdate_i=atoi(marrdate);
  divdate_i= atoi(divdate);


  age=stopdate_i - startdate_i;
  age_place= (age * 5) + 92 ;

  se_age=sevendate_i- startdate_i;
  se_place = (se_age * 5) + 92 ;

  mr_age=marrdate_i- startdate_i;
  mr_place = (mr_age * 5) + 92 ;

  di_age=divdate_i- startdate_i;
  di_place = (di_age * 5) + 92;

  gdx_image(50,225,"images/timeline.xpm");
  label8=gdx_label(indi_birtdate,70,295,0);
  gdx_setlabelbg("images/white.xpm",1,label8);

  if(startdate_i >= 1 && stopdate_i >=1){
     sprintf(age_string,"died at ~%d years old.",age);
     gdx_image(age_place,302,"images/dep.xpm");
  }
  else{
    strcpy(age_string,"Age unknown");
  }

   if(found_even==1) gdx_image(se_place,302,"images/sep.xpm");
   if(found_mar==1) gdx_image(mr_place,302,"images/mep.xpm");
   if(found_div==1) gdx_image(di_place,302,"images/divep.xpm");


  label10=gdx_label(age_string,270,185,1);
  gdx_setlabelbg("images/white.xpm",1,label10);

  gdx_main();
  x_close();
  fclose(fp5); 
  return(0);
}

