//GedSearch
//Written by Michael Gibson
//GPL
//copyright 2009
//searches for a last name, then give id and link

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "GDXlib.h"

char *r_version="0.8.5";

void open_indi(void);
int indi_r=0;
char filename[80];
char temp[80];
char indi_name[60][60];
char indi_surname[40][40];
int indi[60];

char search_surname[40];

int number_of_names=0;  //number of names found
int x=0, y=0;
FILE *fp;

//////////////////////////
//
///////////////////////////
void destroy(void){

gdx_closewindow();
exit(0);

}


//////////////////////////////////////////
/// int main()
/////////////////////////////////////////
int main(int argc, char **argv)
{

  char label_string[150];
  int  label1,label2,label3,label4,label5;
  int  label6,label7,label8,label9,label10;
  int  label11,label12,label13,label14,label15;
  int  label_instance=0;
  int button_01;
  x_open();

  /* create a new window */
  gdx_window("GEDCOM Search",600,400);
  gdx_setwindowbg("images/bg.xpm",1);

  button_01 = gdx_imagebutton(5,10,"images/close.xpm",destroy);



  if(argc==3){
    sprintf(search_surname,"%s",argv[1]);
  }
  else{
    printf("Gedsearch: invalid values passed \n");
    exit(0);
  }

  if(argc==3){
    sprintf(filename,"%s",argv[2]);
  }


  printf("Opening file....\n");
  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM Search: Sorry, no file found. \n");
     exit(0);
  }



///// 0 SUBM -> 1 NAME
do{
  fgets(temp,80,fp);


  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){         //Individual 0 level start of record
      indi_r++;
      temp[0]=' ';
      for(x=0;x<80;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      indi[indi_r]=atoi(temp);
      //printf("-examining INDI = %d \n",indi[indi_r]);
  }


  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){     ///1 NAME
     if(strstr(temp,"/")==0) number_of_names++;

     for(x=7;x<80;x++){temp[x-7]=temp[x];}
     strcpy(indi_name[indi_r],temp);

     indi_name[indi_r][strlen(indi_name[indi_r]) - 1]= ' ';

     //printf("--examine Name = %s\n",indi_name[indi_r]);
     strcat(indi_name[indi_r],"!");  // add a safetly search char
     x=0;
     do{
        indi_name[indi_r][x];
        x++;
     }while(indi_name[indi_r][x] != '/' && indi_name[indi_r][x] != '!');
     indi_name[indi_r][x] = '[';
     y=-1;
     do{
        indi_surname[indi_r][y]=indi_name[indi_r][x];
        x++;
        y++;
     }while(indi_name[indi_r][x] != '/' && indi_name[indi_r][x] != '\0');
     indi_name[indi_r][x] = ']';
     indi_name[indi_r][x+1] = '\0';
     indi_name[indi_r][x+2] = '\0';
     indi_name[indi_r][x+3] = '\0';
     //strcat(indi_surname[indi_r],"\n");

     //printf("surname='%s'\n",indi_surname[indi_r]);

     if(strcmp(indi_surname[indi_r],search_surname)==0){
       label_instance++;
       printf("Found match '%s' at record number %d\n",indi_name[indi_r],indi[indi_r]);
       sprintf(label_string,"Found match '%s' at record # %d",indi_name[indi_r],indi[indi_r]);
       if(label_instance==1)label1 = gdx_label(label_string,55,25,1);
       if(label_instance==2)label2 = gdx_label(label_string,55,50,1);
       if(label_instance==3)label3 = gdx_label(label_string,55,75,1);
       if(label_instance==4)label4 = gdx_label(label_string,55,100,1);
       if(label_instance==5)label5 = gdx_label(label_string,55,125,1);
       if(label_instance==6)label6 = gdx_label(label_string,55,150,1);
       if(label_instance==7)label7 = gdx_label(label_string,55,175,1);
       if(label_instance==8)label8 = gdx_label(label_string,55,200,1);
       if(label_instance==9)label9 = gdx_label(label_string,55,225,1);

     }


  }
}while(temp[0] !='0' || temp[2] !='T');

fclose(fp);


  gdx_main();
  x_close();

  return(0);

 
}
