// markdata.c
//(c) 2007-2009
//written by Michael Gibson
//Under the GPL lic

#include <stdio.h>
#include <string.h>


////////////////////////////////////////
//mark_indi(void)
///////////////////////////////////
void mark_indi(void){

  FILE *fp2;
  char temp2[30];
  char check_string[30];

  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }

  indi_name_m=0;
  indi_titl_m=0;
  indi_occu_m=0;
  indi_note_m=0;
  indi_reli_m=0;
  indi_birt_date_m=0;
  indi_birt_plac_m=0;
  indi_birt_note_m=0;
  indi_deat_date_m=0;
  indi_deat_plac_m=0;
  indi_deat_note_m=0;
  indi_buri_date_m=0;
  indi_buri_plac_m=0;
  indi_buri_note_m=0;
 

  do{
    temp2[0]='x';
    fgets(temp2,30,fp2);
    //0009:name:1:z00001.ged
    sprintf(check_string,"%04d:name:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_name_m=1;

    sprintf(check_string,"%04d:dscr:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_dscr_m=1;

    sprintf(check_string,"%04d:addr:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_addr_m=1;

    sprintf(check_string,"%04d:educ:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_educ_m=1;

    sprintf(check_string,"%04d:titl:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_titl_m=1;

    sprintf(check_string,"%04d:occu:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_occu_m=1;

    sprintf(check_string,"%04d:reli:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_reli_m=1;
    
    sprintf(check_string,"%04d:Note:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_note_m=1;

    sprintf(check_string,"%04d:bd__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_birt_date_m=1;

    sprintf(check_string,"%04d:bp__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_birt_plac_m=1;

    sprintf(check_string,"%04d:bn__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_birt_note_m=1;

    sprintf(check_string,"%04d:dd__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_deat_date_m=1;

    sprintf(check_string,"%04d:dp__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_deat_plac_m=1;

    sprintf(check_string,"%04d:dn__:1:%s",atoi(indi_num),filename);
    if(strncmp(check_string,temp2,15)==0)indi_deat_note_m=1;


  }while(temp2[0]!='x');

fclose(fp2);
}

/////////////////////////////////////////////////////
//mark_name(void)
////////////////////////////////////////////////////
void mark_name(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:name:1:z00001.ged
    sprintf(check_string1,"%04d:name:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:name:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='n'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_name_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_name,"images/update2.xpm");
    entry_found=1;
    indi_name_m=1;
  }
  if(indi_name_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_name,"images/update.xpm");
    indi_name_m=0;
  }
fclose(fp2);
}



/////////////////////////////////////////////////////
//mark_dscr(void)
////////////////////////////////////////////////////
void mark_dscr(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:dscr:1:z00001.ged
    sprintf(check_string1,"%04d:dscr:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:dscr:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='d'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_dscr_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_dscr,"images/update2.xpm");
    entry_found=1;
    indi_dscr_m=1;
  }
  if(indi_dscr_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_dscr,"images/update.xpm");
    indi_dscr_m=0;
  }
fclose(fp2);
}



/////////////////////////////////////////////////////
//mark_titl(void)
////////////////////////////////////////////////////
void mark_titl(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:titl:1:z00001.ged
    sprintf(check_string1,"%04d:titl:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:titl:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    //if entry needs to stay, and it does not belong to you,
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='t'))   fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_titl_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_titl,"images/update2.xpm");
    entry_found=1;
    indi_titl_m=1;
  }
  if(indi_titl_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_titl,"images/update.xpm");
    indi_titl_m=0;
  }
fclose(fp2);
}

/////////////////////////////////////////////////////
//mark_occu(void)
////////////////////////////////////////////////////
void mark_occu(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:occu:1:z00001.ged
    sprintf(check_string1,"%04d:occu:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:occu:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    //if entry needs to stay, and it does not belong to you,
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='o'))   fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_occu_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_occu,"images/update2.xpm");
    entry_found=1;
    indi_occu_m=1;
  }
  if(indi_occu_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_occu,"images/update.xpm");
    indi_occu_m=0;
  }
fclose(fp2);
}


/////////////////////////////////////////////////////
//mark_note(void)
////////////////////////////////////////////////////
void mark_note(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:note:1:z00001.ged
    sprintf(check_string1,"%04d:note:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:note:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    //if entry needs to stay, and it does not belong to you,
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='n' && temp2[x][6]!='o'))   fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_note_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_note,"images/update2.xpm");
    entry_found=1;
    indi_note_m=1;
  }
  if(indi_note_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_note,"images/update.xpm");
    indi_note_m=0;
  }
fclose(fp2);
}


/////////////////////////////////////////////////////
//mark_educ(void)
////////////////////////////////////////////////////
void mark_educ(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:educ:1:z00001.ged
    sprintf(check_string1,"%04d:educ:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:educ:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    //if entry needs to stay, and it does not belong to you,
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='e'))   fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_educ_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_educ,"images/update2.xpm");
    entry_found=1;
    indi_educ_m=1;
  }
  if(indi_educ_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_educ,"images/update.xpm");
    indi_educ_m=0;
  }
fclose(fp2);
}


/////////////////////////////////////////////////////
//mark_addr(void)
////////////////////////////////////////////////////
void mark_addr(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:addr:1:z00001.ged
    sprintf(check_string1,"%04d:addr:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:addr:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    //if entry needs to stay, and it does not belong to you,
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='a'))   fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_addr_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_addr,"images/update2.xpm");
    entry_found=1;
    indi_addr_m=1;
  }
  if(indi_addr_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_addr,"images/update.xpm");
    indi_addr_m=0;
  }
fclose(fp2);
}



/////////////////////////////////////////////////////
//mark_reli(void)
////////////////////////////////////////////////////
void mark_reli(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:reli:1:z00001.ged
    sprintf(check_string1,"%04d:reli:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:reli:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    //if entry needs to stay, and it does not belong to you,
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='r'))   fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_reli_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_reli,"images/update2.xpm");
    entry_found=1;
    indi_reli_m=1;
  }
  if(indi_reli_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_reli,"images/update.xpm");
    indi_reli_m=0;
  }
fclose(fp2);
}


/////////////////////////////////////////////////////
//mark_birt_date(void)
////////////////////////////////////////////////////
void mark_birt_date(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:bd__:1:z00001.ged
    sprintf(check_string1,"%04d:bd__:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:bd__:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='d'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_birt_date_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_birt_date,"images/update2.xpm");
    entry_found=1;
    indi_birt_date_m=1;
  }
  if(indi_birt_date_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_birt_date,"images/update.xpm");
    indi_birt_date_m=0;
  }
fclose(fp2);
}


/////////////////////////////////////////////////////
//mark_birt_plac(void)
////////////////////////////////////////////////////
void mark_birt_plac(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:bp__:1:z00001.ged
    sprintf(check_string1,"%04d:bp__:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:bp__:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='p'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_birt_date_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_birt_plac,"images/update2.xpm");
    entry_found=1;
    indi_birt_plac_m=1;
  }
  if(indi_birt_date_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_birt_plac,"images/update.xpm");
    indi_birt_plac_m=0;
  }
fclose(fp2);
}

/////////////////////////////////////////////////////
//mark_birt_note(void)
////////////////////////////////////////////////////
void mark_birt_note(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:bn__:1:z00001.ged
    sprintf(check_string1,"%04d:bn__:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:bn__:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='n'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_birt_note_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_birt_note,"images/update2.xpm");
    entry_found=1;
    indi_birt_note_m=1;
  }
  if(indi_birt_note_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_birt_note,"images/update.xpm");
    indi_birt_note_m=0;
  }
fclose(fp2);
}

/////////////////////////////////////////////////////
//mark_deat_date(void)
////////////////////////////////////////////////////
void mark_deat_date(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:dd__:1:z00001.ged
    sprintf(check_string1,"%04d:dd__:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:dd__:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='d' && temp2[x][6]!='d'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_deat_date_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_deat_date,"images/update2.xpm");
    entry_found=1;
    indi_deat_date_m=1;
  }
  if(indi_deat_date_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_deat_date,"images/update.xpm");
    indi_deat_date_m=0;
  }
fclose(fp2);
}



/////////////////////////////////////////////////////
//mark_deat_note(void)
////////////////////////////////////////////////////
void mark_deat_note(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:dn__:1:z00001.ged
    sprintf(check_string1,"%04d:dn__:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:dn__:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='d' && temp2[x][6]!='n'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_deat_note_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_deat_note,"images/update2.xpm");
    entry_found=1;
    indi_deat_note_m=1;
  }
  if(indi_deat_note_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_deat_note,"images/update.xpm");
    indi_deat_note_m=0;
  }
fclose(fp2);
}



/////////////////////////////////////////////////////
//mark_buri_date(void)
////////////////////////////////////////////////////
void mark_buri_date(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:buda:1:z00001.ged
    sprintf(check_string1,"%04d:buda:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:buda:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='u' && temp2[x][7]!='d'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_buri_date_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_buri_date,"images/update2.xpm");
    entry_found=1;
    indi_buri_date_m=1;
  }
  if(indi_buri_date_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_buri_date,"images/update.xpm");
    indi_buri_date_m=0;
  }
fclose(fp2);
}


/////////////////////////////////////////////////////
//mark_buri_plac(void)
////////////////////////////////////////////////////
void mark_buri_plac(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:bupl:1:z00001.ged
    sprintf(check_string1,"%04d:bupl:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:bupl:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='u'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_buri_plac_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_buri_plac,"images/update2.xpm");
    entry_found=1;
    indi_buri_plac_m=1;
  }
  if(indi_buri_plac_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_buri_plac,"images/update.xpm");
    indi_buri_plac_m=0;
  }
fclose(fp2);
}
///////////////////
// buri note mark
//////////////////
void mark_buri_note(void){
  FILE *fp2;
  int entry_found=0;
  char temp[30];
  char temp2[30][30];
  char check_string1[30];
  char check_string2[30];
  int loop=0;
  int x=0;
  if((fp2=fopen("GEDCOM_mark.dat","r"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  do{
    temp[0]='\0';
    temp[1]='\0';
    fgets(temp,30,fp2);
    strcpy(temp2[loop],temp);
    loop++;
  }while(temp[0]!='\0');
    //0009:buno:1:z00001.ged
    sprintf(check_string1,"%04d:buno:1:%s\n",atoi(indi_num),filename);
    sprintf(check_string2,"%04d:buno:0:%s\n",atoi(indi_num),filename);
  fclose(fp2);
  if((fp2=fopen("GEDCOM_mark.dat","w"))==NULL ){
     printf("GEDCOM indi: Sorry, no dat file found. \n");
     exit(0);
  }
  for(x=0;x<=loop;x++){
    if((temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) !=0 ) ||
        (temp2[x][10]=='1' && (strncmp(temp2[x],indi_num,4)) ==0 && temp2[x][5]!='b' && temp2[x][6]!='u'&& temp2[x][7]!='n'))fprintf(fp2,"%s",temp2[x]);
  }//end for
  if(indi_buri_note_m==0){
    fprintf(fp2,"%s",check_string1);
    gdx_imagebuttonupdate(flex_buri_note,"images/update2.xpm");
    entry_found=1;
    indi_buri_note_m=1;
  }
  if(indi_buri_note_m==1 && entry_found==0){
    fprintf(fp2,"%s",check_string2);
    gdx_imagebuttonupdate(flex_buri_note,"images/update.xpm");
    indi_buri_note_m=0;
  }
fclose(fp2);
}

